const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FlagsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const flags = await db.flags.create(
      {
        id: data.id || undefined,

        reason: data.reason || null,
        status: data.status || null,
        notes: data.notes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await flags.setProfile_page(data.profile_page || null, {
      transaction,
    });

    await flags.setOrganizations(data.organizations || null, {
      transaction,
    });

    return flags;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const flagsData = data.map((item, index) => ({
      id: item.id || undefined,

      reason: item.reason || null,
      status: item.status || null,
      notes: item.notes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const flags = await db.flags.bulkCreate(flagsData, { transaction });

    // For each item created, replace relation files

    return flags;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const flags = await db.flags.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.reason !== undefined) updatePayload.reason = data.reason;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.notes !== undefined) updatePayload.notes = data.notes;

    updatePayload.updatedById = currentUser.id;

    await flags.update(updatePayload, { transaction });

    if (data.profile_page !== undefined) {
      await flags.setProfile_page(
        data.profile_page,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await flags.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return flags;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const flags = await db.flags.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of flags) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of flags) {
        await record.destroy({ transaction });
      }
    });

    return flags;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const flags = await db.flags.findByPk(id, options);

    await flags.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await flags.destroy({
      transaction,
    });

    return flags;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const flags = await db.flags.findOne({ where }, { transaction });

    if (!flags) {
      return flags;
    }

    const output = flags.get({ plain: true });

    output.profile_page = await flags.getProfile_page({
      transaction,
    });

    output.organizations = await flags.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.profile_pages,
        as: 'profile_page',

        where: filter.profile_page
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.profile_page
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.profile_page
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.notes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('flags', 'notes', filter.notes),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.reason) {
        where = {
          ...where,
          reason: filter.reason,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.flags.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('flags', 'reason', query),
        ],
      };
    }

    const records = await db.flags.findAll({
      attributes: ['id', 'reason'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['reason', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.reason,
    }));
  }
};
